#include <stdio.h>
#include <string.h>
#include <libpq-fe.h>
#include <stdarg.h>
#include <time.h>

PGconn *conn;
PGresult *res;

PGresult *execSQL (char *format, ...)
{
	va_list ap;
	static char command[1024];
	PGresult *retval;
	time_t t;
	int nTuples;
	static int waiting = 0;
	FILE *fp;

	while (fp = fopen("/home/postgres/backup_running", "r"))
	{
		fclose (fp);
		waiting = 1;
		system ("message_box Backup is currently running .. please wait");
	}

	t = time(NULL);
	
	va_start (ap, format);
	vsprintf (command, format, ap);
	printf ("%s\t- '%s'\n", ctime (&t), command);
	retval = PQexec (conn, command);

	if (!retval)
	{
		printf ("\t  *** ERROR ***\n\n");
		printf ("A database error has occured - check log file !\n");
		return NULL;
	}
	if (!memcmp (command, "select", 6) && (PQresultStatus(retval) != PGRES_TUPLES_OK))
	{
		printf ("\t  *** ERROR (%d) ***\n", PQresultStatus (retval));
		printf ("A database error has occured - check log file !\n");
	}
	else if (memcmp (command, "select", 6))
	{
		nTuples = PQresultStatus (retval);
		printf ("\t  (%d updates)\n\n", nTuples);
	}
	else
	{
		nTuples = PQntuples (retval);
		printf ("\t  (%d Rows)\n\n", nTuples);
	}

	va_end (ap);
	return retval;
}

char *trim (char *str)
{
	char *ptr;

	ptr = str + strlen(str) - 1;
	while (ptr > str)
	{
		switch (*ptr)
		{
			case ' ':
			case '\t':
			case '\n':
				*ptr = 0;
				break;
			default:
				return str;
				break;
		}
		ptr--;
	}

	return str;
}

int main (int argc, char **argv)
{
	FILE *debug_file;
	char *hostname = NULL;
	char *databasename = "hotpizza";
	int pgport = 5432;
	char *pgoptions = NULL;
	char *pgtty = NULL;
	int i, nTuples;
	char *pghost = NULL;
	int  userid = 500;
	char Buffer[255];

	// connect to postgres

	pghost = hostname;
    pgport = NULL;              /* port of the backend server */
    pgoptions = NULL;           /* special options to start up the backend
                                 * server */
    pgtty = NULL;               /* debugging tty for the backend server */

    /* make a connection to the database */
    conn = PQsetdb(pghost, pgport, pgoptions, pgtty, databasename);

    /* check to see that the backend connection was successfully made */
    if (PQstatus(conn) == CONNECTION_BAD)
    {
        fprintf(stderr, "Connection to database '%s' failed.\n", databasename);
        fprintf(stderr, "%s", PQerrorMessage(conn));
    }

	PQclear (execSQL ("begin"));

	res = execSQL ("delete from phone");
	PQclear (res);

	res = execSQL ("select custnum, phone from customers");
	nTuples = PQntuples (res);
	for (i = 0; i < nTuples; i++)
	{
		printf ("%s  %s\n", PQgetvalue (res,i,0), PQgetvalue (res,i,1));
		if (strlen (trim(PQgetvalue (res,i,1))))
		{
		PQclear (execSQL("insert into phone values ('%s',%s)",
			PQgetvalue (res,i,1),
			PQgetvalue (res,i,0)));
		}
	}
	PQclear (res);

	PQclear (execSQL ("commit"));
	return 0;
}
